// RSI Smoothed BandsFBA Oscillator                                             
#property copyright "Scriptong"
#property link      "scriptong@mail.ru"

#property indicator_separate_window                         //    
#property indicator_buffers 3                                     //   5
                                          //       
#property indicator_color1 Blue                                  //    
#property indicator_color2 Red                                    //    
#property indicator_color3 MediumSeaGreen       //    BandsFBA Oscillator

extern string  TimeFrame        = "Current time frame";
extern int RSIPrice = PRICE_CLOSE;    //  RSI: 0 - Close, 1 - Open, 2 - High  . .
extern int RSIPeriod = 11;                                     //    RSI
extern int MA_Period = 8;                                 //   
extern int MA_Mode = MODE_LWMA;              //   : 0 - ,
                         // 1 - , 2 - , 3 - -
extern int BandsPeriod = 27;                                    //    
extern double K_Dev = 3.6;                      //  .   
extern int BandsFBAPeriod = 20;                                 //   BB
extern int BandsShift = 0;                                       //   
extern int OscPrice = 0;                                   //   (. )
extern double FrontPeriod = 1;                     //   ; .. <1
extern double BackPeriod = 55;                  //   ; .. <1
extern int Sens = 0;                                     //    .

double RSIBuffer[];               //       RSI
double RSI[];                                 //      RSI

double Up_Buffer[];                                //      
double Dn_Buffer[];                                 //      
double Main[];                                 //      
string indicatorFileName;
bool   returnBars;
int    timeFrame;

bool first = 1;                                                  //   
double per0,per1;                                                        // - EMA
int FBA=0;         // 1 -  , -1 -  , 0 -  MA
double sens;                                           //    

int init()
{
   IndicatorBuffers(5);
   SetIndexStyle(0, DRAW_LINE); 
   SetIndexBuffer(0, Up_Buffer);                   //     . 
   SetIndexDrawBegin(0, BandsPeriod);                //     BB

   SetIndexStyle(1, DRAW_LINE);                                            //  
   SetIndexBuffer(1, Dn_Buffer);                   //     . 
   SetIndexDrawBegin(1, BandsPeriod);                 //     BB

   SetIndexBuffer(2, Main);                        //     . 
   SetIndexStyle(2, DRAW_LINE);                                            //  
    SetIndexStyle(3, DRAW_NONE);      //   - ,    
   SetIndexBuffer(3, RSIBuffer);                   //     . 

   SetIndexBuffer(4, RSI);                         //     . 
      

   first = 1;
   sens = Sens*Point;                                   //    

   if(FrontPeriod>1) FrontPeriod=2.0/(1+FrontPeriod);       // .  EMA
   if(BackPeriod>1) BackPeriod=2.0/(1+BackPeriod);               // .  EMA
   
   // FrontPeriod  BackPeriod      
   while(true) 
     {
      if (FrontPeriod==BackPeriod) 
        {
         per0=FrontPeriod; 
         per1=1; 
         break;
        }
      if (FrontPeriod>BackPeriod) 
        {
         FBA = -1;
         per0 = FrontPeriod;
         per1=BackPeriod;
        }
       else
        {
         FBA = 1; 
         per0 = BackPeriod; 
         per1 = FrontPeriod;
        }
      break;
     }
     
     indicatorFileName = WindowExpertName();
     returnBars        = TimeFrame == "returnBars";     if (returnBars)     return(0);
     timeFrame         = stringToTimeFrame(TimeFrame);
     IndicatorShortName(timeFrameToString(timeFrame)+" RSI_Smoothed_BB("+RSIPeriod+","+BandsPeriod+","+ DoubleToStr(K_Dev, 2)+")");

   return(0);
   }

int reinit()                                      //   
  {
   ArrayInitialize(Main,0.0);
   return(0);
  }
  
int start()
{ 
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { Up_Buffer[0] = limit+1; return(0); }
   
            if (timeFrame!=Period())
            {
               limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
               for (int i=limit; i>=0; i--)
               {
                   int y = iBarShift(NULL,timeFrame,Time[i]);              
                      Up_Buffer[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RSIPrice,RSIPeriod,MA_Period,MA_Mode,BandsPeriod,K_Dev,BandsFBAPeriod,BandsShift,OscPrice,FrontPeriod,BackPeriod,Sens,0,y);
                      Dn_Buffer[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RSIPrice,RSIPeriod,MA_Period,MA_Mode,BandsPeriod,K_Dev,BandsFBAPeriod,BandsShift,OscPrice,FrontPeriod,BackPeriod,Sens,1,y);
                      Main[i]      = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RSIPrice,RSIPeriod,MA_Period,MA_Mode,BandsPeriod,K_Dev,BandsFBAPeriod,BandsShift,OscPrice,FrontPeriod,BackPeriod,Sens,2,y);
               }
               return(0);
            }
// - 1 - ==============================    ? =============================
   if (Bars <= RSIPeriod || Bars <= BandsPeriod || Bars <= BandsFBAPeriod)        // 
         return(0);                                        //   ,  
// - 1 - ================================   ===============================

// - 2 - =========================     ====================
   int ic=IndicatorCounted();                            //   
   if (!first && Bars-ic-1 > 1) ic = reinit(); 
   limit=Bars-ic-1; 
// - 2 - ================================   ===============================
   
// - 3 - =========================    RSI ====================
   for (i = limit; i >= 0; i--)
     RSI[i] = iRSI(NULL, 0, RSIPeriod, RSIPrice, i);
   i = limit;                   
// - 3 - ================================   ===============================
     
// - 4 - ===================     RSI ==============
   for (i = limit; i >= 0; i--)
      {
      RSIBuffer[i] = iMAOnArray(RSI,0,MA_Period,0,MA_Mode,i);
// - 4 - ================================   ===============================

// - 5 - =======    ,    RSI =======
      double sum = 0.0;                                         //  
      int k = i + BandsPeriod - 1;                  //     
      while(k >= i)                     //      
        {
         double newres = RSIBuffer[k] - 50;                                 // 
         sum += newres*newres;                              //   
         k--;
        }
      double deviation = K_Dev*MathSqrt(sum/BandsPeriod);           //  
      Up_Buffer[i]= 50 + deviation;                                   //   
      Dn_Buffer[i]= 50 - deviation;                                    //   
// - 5 - ================================   ===============================
     
// - 6 - ====================      ==============
      bool reset = i==limit && ic==0;         //      
      if (reset) 
        {
         static double MA0prev=0, MA1prev=0, sma0prev=0; 
         static int BarsPrev=0;
        }
        
      int sh = i + BandsShift;                                                   // 

      double sma = iMA(NULL, 0, BandsPeriod, 0, 0, 0, sh);     //  Bollinger Bands
 
      double st=iStdDev(NULL, 0, BandsPeriod, 0, 0, 0, sh);       //   
      st = MathMax(st, sens);                            //   
      double std = 2*st;                                                      // 
      
      //  Bollinger Bands FBA
      double topB = sma + std;                                           //  
      double botB = sma-std;                                              //  

      //  
      double MA0 = EMA_FBA(st, MA0prev, per0, 0, i);
      double sma0 = EMA_FBA(sma, sma0prev, per0, 0, i);
      
      double MA1=EMA_FBA(MA0, MA1prev, per1, FBA, i);         //  ()
      
      double price = Price(OscPrice,i);
      double deltaB = topB - botB;                                       //  
      if (deltaB == 0) 
        double main = 1;
       else 
        main = (price-botB)/deltaB;
      Main[i] = 100*main;       //       
    
      // 
      if (first || BarsPrev != Bars) 
        { 
         BarsPrev = Bars;
         MA0prev = MA0;
         MA1prev = MA1;
         sma0prev = sma0;
        }
// - 6 - ================================   ===============================
      }
   return(0);
  }
   
// EMA        
double EMA_FBA(double C, double MA1, double period, int tFBA, int i) 
  {
   if(period == 1) return(C);
   // . EMA 
   if(period>1) period=2.0/(1+period); 
   // EMA
   double ma=period*C+(1-period)*MA1; 
   //    
   switch(tFBA) {
      case  0: //  MA
         if(tFBA==0) return(ma); 
      case  1: //  
         if(C>MA1) return(ma); else return(C); 
      case -1: //  
         if(C<MA1) return(ma); else return(C); 
     }
     return(ma);
  }
  
double Price(int ApplPrice, int i) 
  {
   switch(ApplPrice) 
     {
      case 0: return(Close[i]);
      case 1: return(Open[i]);
      case 2: return(High[i]);
      case 3: return(Low[i]); 
      case 4: return((High[i]+Low[i])/2); // Middle
      case 5: return((High[i]+Low[i]+Close[i])/3); // Typical
      case 6: return((High[i]+Low[i]+2*Close[i])/4); // Weighted
      default: return(Close[i]); // Close
     }
  }

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}


